"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class DiseasePenetrance(ProtocolElement):
    """
    A disease penetrance definition
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "penetrance",
        "specificDisease",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import participant as participant_1_5_0

        return {
            "penetrance": participant_1_5_0.Penetrance,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.Penetrance": participant_1_5_0.Penetrance,
            "org.gel.models.participant.avro.DiseasePenetrance": participant_1_5_0.DiseasePenetrance,
        }

    __slots__ = [
        "penetrance",
        "specificDisease",
    ]

    def __init__(
        self,
        penetrance,
        specificDisease,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.DiseasePenetrance model.

        :param penetrance:
            The penetrance
        :type penetrance: Penetrance
        :param specificDisease:
            The disease to which the penetrance applies
        :type specificDisease: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
